'MANIC MINER (C) BUG-BYTE ltd. 1983 by Matthew Smith
'Colour Maximite conversion August 2019 by ceptimus. This is V0.9c
'Bug reports and comments to ceptimus@ceptimus.co.uk

'Dim L(256),S(2162)
'js=1:jsL=13:jsR=14:jsF=15:jsM=7:mfps=11.98:sfps=12.71:nd=150
Option USB Off:Mode 4
k=S(0)'If you see an error here         Run "MMINER.BAS" not this program.

Dim z2m(7) 'ZX convert Spectrum palette to Colour MaxiMite
For k=0 To 7:Read z2m(k):Next:Data 0,1,4,5,2,3,6,7
Dim G(15) 'guardian info
Dim I(4) 'item info
Dim bga(7) 'block graphic attributes
Dim a2c(63) 'char from attribute: inverse of bga()
Dim M(16) 'in-game music

Sub kp(p$) 'key prompts
  Local s$,c,n
  s$=" Pause Music Sound Quit"
  b$=CLR$(2):c$=CLR$(3):n=Len(p$+s$)
  Font#4
  If dm Then
    Colour 4,0:Print@(0,208)"Demo:space bar or fire to play";
  Else
    Colour 3,0:Print@(240-8*n,208)p$;
    For n=1 To Len(s$):c=Asc(Mid$(s$,n)):Print Chr$(c);
    If c=32 Then Colour 3 Else Colour 1
    Next
  EndIf
  Font#5
End Sub

Sub il(lev)
  Local fn$,i,a,j,k,rw,cn,x,y,f,spr
  fn$="\MMLEV"+Format$(lev,"%02.0f")+"."
  Open"LEVELS"+fn$+"BIN"For INPUT As#1
  For i=0 To 1023:Poke VAR L(0),i,Asc(Input$(1,#1)):Next:Close#1

  Open"DATA"+fn$+"BIN"For INPUT As#1
  For i=0 To 7
    bga(i)=Asc(Input$(1,#1)):Poke VAR a2c(0),bga(i),i+21
  Next:Close#1:Poke VAR a2c(0),bga(2),34
  For i=34 To 41:Poke VAR a2c(0),100+i,i:Next 'crumbling floor
  bg=z2m((bga(0) And 56)\8) 'background colour
  Font Load"FONTS"+fn$+"FNT"As#5
  Sprite Load"SPRITES"+fn$+"SPR"

  'i=Peek(VAR L(0), 627) And 7:Colour z2m(i xor 7),z2m(i)
  Colour 7,0 'official border colours too bright on MM, IMO
  Cls:Mode 4:Font#4
  If lev=20 Then LoadBMP"GRAPHICS\MMLEV20.BMP"

'Room-Name
  Colour 0,6:Font #4:Print@(0,16*8+8);
  For i=513 To 542:Print Chr$(Peek(VAR L(0),i));:Next
'Air and scores
  Colour 7,4:Print"AIR"Space$(6);:Colour 7,2:Print Space$(21);
  ai=(Peek(VAR L(0),700)-36)*8
  j=128:For i=0 To 7:If Peek(VAR L(0),701) And j Then ai=ai+1
  j=j\2:Next:oS=Int(32.5+ai*206/222):Line(32,146)-(oS-1,149),7,BF
  Colour 6,0:Print@(0,160)"Hi Score "Format$(hs,"%06.0f");
  Print"   Score "Format$(sc,"%06.0f");
'Screen-Layout
  Font#5:i=1:Print@(0,8);:k=0
  If lev=20 Then Print@(0,72);:k=8:i=257
  For rw=k To 15
    For cn=1 To 30
      a=Peek(VAR L(0),i) 'attribute
      Colour z2m(a And 7),z2m((a And 56)\8)
      Print Chr$(Peek(VAR a2c(0),a));
      If a=bga(2) Then Poke VAR L(0),i,134 'substitute crumbling floor
      i=i+1
    Next
    i=i+2
  Next
'Portal
  a=Peek(VAR L(0), 655):j=Peek(VAR L(0),688):k=Peek(VAR L(0),689)
  pInk=z2m(a And 7):pPpr=z2m((a And 56)\8)
  cn=j And 31:rw=(j And 224)\32:If k And 1 Then rw=rw+8
  pX=cn*8-8:pY=rw*8+8
  Poke VAR L(0),rw*32+cn,130:Poke var L(0),rw*32+cn+1,131
  Poke VAR L(0),rw*32+cn+32,132:Poke var L(0),rw*32+cn+33,133
'Guardians
  ng=0
  If lev>7 And lev<>10 And lev<>16)Then 'vert grdns
    spr=45:j=9:For i=733 To 754 Step 7
      a=Peek(var L(0),i):If (lev=8 Or lev=12) And j=9 Then a=4
      If a=255 Then Exit For
      If a Then
        f=Peek(var L(0),i+1) And 3 'sprite frame 0-3
        y=Peek(var L(0),i+2) 'pixels
        x=Peek(var L(0),i+3) And 31
        'Sprite copy j+f To spr
        'Sprite on spr,x*8-8,y+8
        k=1 'vert
        If lev=14 Then k=2 'skylab
        If (lev=8 Or lev=12) And j=9 Then x=15:k=3 'kong
        Poke var G(0),ng*8+0,k
        Poke var G(0),ng*8+1,spr
        Poke var G(0),ng*8+2,j+f
        Poke var G(0),ng*8+3,x
        Poke var G(0),ng*8+4,y
        Poke var G(0),ng*8+5,Peek(var L(0),i+4) 'velocity
        Poke var G(0),ng*8+6,Peek(var L(0),i+5) 'top (low)
        Poke var G(0),ng*8+7,Peek(var L(0),i+6) 'bottom (high)
        ng=ng+1
        spr=spr+1
      EndIf
      j=j+4:If lev=14 Then j=j+4
    Next
  EndIf
  If lev>7 And lev<>10 And lev<>14 And lev<>14 And lev<>16 Then 'horiz grdns
    spr=49:j=25:For i=702 To 723 Step 7
      a=Peek(var L(0),i):If a=255 Then Exit For
      If a Then
        x=Peek(var L(0),i+1) And 31
        y=(Peek(var L(0),i+1) And 224)\32
        If Peek(var L(0), i+2) And 1 Then y=y+8
        Poke var G(0),ng*8+0,4 'horiz
        Poke var G(0),ng*8+1,spr
        Poke var G(0),ng*8+2,(j-25)*16+Peek(var L(0),i+4) 'spriteFrame|f
        Poke var G(0),ng*8+3,x
        Poke var G(0),ng*8+4,y
        Poke var G(0),ng*8+5,a 'slow bit from attribute
        Poke var G(0),ng*8+6,Peek(var L(0),i+5)And 31 'left (low)
        Poke var G(0),ng*8+7,Peek(var L(0),i+6)And 31 'right (high)
        ng=ng+1:spr=spr+1
      EndIf
      j=j+4
    Next
  EndIf
  If lev<8 Or lev=10 Or lev=16 Then 'bi-horiz grdns
    spr=45:j=9:For i=702 To 723 Step 7
      a=Peek(var L(0),i):If a=255 Then Exit For
      If a Then
        x=Peek(var L(0),i+1) And 31
        y=(Peek(var L(0),i+1) And 224)\32
        If Peek(var L(0), i+2) And 1 Then y=y+8
        Poke var G(0),ng*8+0,5 'bi-horiz
        Poke var G(0),ng*8+1,spr
        Poke var G(0),ng*8+2,(j-9)*8+Peek(var L(0),i+4) 'spriteFrame|f
        Poke var G(0),ng*8+3,x
        Poke var G(0),ng*8+4,y
        Poke var G(0),ng*8+5,a 'slow bit from attribute
        Poke var G(0),ng*8+6,Peek(var L(0),i+5)And 31 'left (low)
        Poke var G(0),ng*8+7,Peek(var L(0),i+6)And 31 'right (high)
        ng=ng+1:spr=spr+1
      EndIf
      j=j+8
    Next
  EndIf
  If lev=5 Then 'Eugene
    Poke var G(0),ng*8+0,6
    Poke var G(0),ng*8+1,spr
    Poke var G(0),ng*8+2,40
    Poke var G(0),ng*8+3,15
    Poke var G(0),ng*8+4,0
    Poke var G(0),ng*8+5,1
    Poke var G(0),ng*8+6,1
    Poke var G(0),ng*8+7,88
    ng=ng+1:spr=spr+1
  EndIf
'Willy
  wX=Peek(var L(0),620)And 31:k=Peek(var L(0),616):wY=(k And 240)\16
  wPy=k And 7 'wX,wY attrib coords, wPy pixel offset
  wS=Peek(var L(0),617):wD=Peek(var L(0),618) 'wS sprite 0-3, wD 0=right,1=left
  wM=0:wF=0:wC=0 'standing, fell zero height, alive
  Sprite off 53:Sprite copy wS+wD*4+1 To 53
  If dm=0 Then Sprite on 53,wX*8-8,wY*8+8+wPy
'Conveyor
  i=Peek(var L(0),624):c3=(i And 31)*8-8:c2=((i And 224)\32)*8+8
  c4=Peek(var L(0),626)*8-2:If Peek(var L(0),625)And 8 Then c2=c2+64
  c6=c2+2:c7=c2:c8=c6:If Peek(var L(0),623) Then i=c2:c2=c6:c6=i
  c1=c3+2:c5=c3+c4-6:c9=c3+c4+1
'Items
  nI=0
  For i=629 To 649 Step 5
    a=Peek(VAR L(0),i):If a=255 Then Exit For
    If a Then
      j=Peek(VAR L(0),i+1):k=Peek(VAR L(0),i+2)
      cn=j And 31: rw=(j And 224)\32:If k And 1 Then rw=rw+8
      Poke VAR L(0),rw*32+cn,200+nI
      Poke VAR I(0),nI*4+0,a
      Poke VAR I(0),nI*4+1,cn*8-8
      Poke VAR I(0),nI*4+2,rw*8+8
      Poke VAR I(0),nI*4+3,rw*32+cn
      nI=nI+1:If nI<5 Then Poke VAR I(0),nI*4,255
      If lev=7 Or lev=17 Then
        Colour 7,z2m(bga(2) And 7)
        Print@(cn*8-8,rw*8+8)Chr$(21);
      EndIf
    EndIf
  Next
  If cm Then kp("PgUp/Dn") Else kp("")
  If lev=19 Then pS=1:fS=0:Colour 0,6:Print@(176,8)Chr$(21);
End Sub

Sub mvGrd 'move guardians
  Local a,i,t,sn,n,x,y,inc,low,hi,sf,ox
  For i=0 To ng-1
    t = Peek(var G(0),i*8)
    sn= Peek(var G(0),i*8+1)
    n = Peek(var G(0),i*8+2)
    x = Peek(var G(0),i*8+3)
    y = Peek(var G(0),i*8+4)
    inc=Peek(var G(0),i*8+5):If inc>127 Then inc=inc-256
    low=Peek(var G(0),i*8+6)
    hi= Peek(var G(0),i*8+7)
    If t=1 Or t=6 Then
'vert or eugene
      ox=y
      If t=6 Then
        If ni=0 Then
          inc=1:n=n+1:If n>40 Then n=33
        Else
          n=40
        EndIf
      Else
        If (n And 3)=0 Then n=n-3 Else n=n+1 'frame #
      EndIf
      Poke var G(0),i*8+2,n
      y=y+inc
      If (inc<0 And y<low)Or(inc>0 And y>=hi)Then
        y=y-inc:inc=-inc
      EndIf
      If inc<0 Then inc=256+inc
      Poke var G(0),i*8+4,y:Poke var g(0),i*8+5,inc
      Sprite off sn:Sprite copy n To sn:Sprite on sn,x*8-8,y+8
    ElseIf t=2 Then
'skylab
      If (n And 7)=0 Then
        n=n-7:y=low:x=(x+8)And 31
        Poke var G(0),i*8+2,n:Poke var G(0),i*8+3,x
        Poke var G(0),i*8+4,y
      Else
        y=y+inc:If y>=hi Then y=hi:n=n+1:Poke var G(0),i*8+2,n
        Poke var G(0),i*8+4,y
      EndIf
      Sprite off sn:Sprite copy n To sn:Sprite on sn,x*8-8,y+8,bg
    ElseIf t=3 Then
'kong
      If (gf And 7)=0 Then
        If (n And 1)=0 Then n=n-1 Else n=n+1
        Poke var G(0),i*8+2,n
      EndIf
      If n>10 Then
        y=y+4:Poke VAR G(0),i*8+4,y:If y<104 Then score 100:kf=kf*2000/2129
      EndIf
      Sprite off sn:Sprite copy n To sn:Sprite on sn,x*8-8,y+8,bg
      If y>=104 Then Poke VAR G(0),i*8,0:kf=0:po
    ElseIf t=4 Then
'horiz
      a=Peek(VAR G(0),i*8+5)
      ox=x
      If (a And 128)=0 Or (gf And 1)=0 Then 'not 1/2 speed
        sf=(n And 240)\16+25:n=n And 7
        If n And 4 Then 'moving left
          If n=4 Then
            n=7:x=x-1
            If x<low Then
              n=0:x=x+1
            EndIf
          Else
            n=n-1
          EndIf
        Else 'moving right
          If n=3 Then
            n=0:x=x+1
            If x>hi Then
              n=7:x=x-1
            EndIf
          Else
            n=n+1
          EndIf
        EndIf
        Poke VAR G(0),i*8+2,n+(sf-25)*16:Poke var G(0),i*8+3,x
        Sprite off sn:Sprite copy sf+(n And 3) To sn
        Sprite on sn,x*8-8,y*8+8
      EndIf
    ElseIf t=5 Then
'bi-horiz
      a=Peek(var G(0),i*8+5)
      If (a And 128)=0 Or (gf And 1)=0 Then 'not 1/2 speed
        sf=(n And 240)\8+9:n=n And 7
        If n And 4 Then 'moving right
          If n=7 Then
            n=4:x=x+1
            If x>hi Then
              n=3:x=x-1
            EndIf
          Else
            n=n+1
          EndIf
        Else 'moving left
          If n=0 Then
            n=3:x=x-1
            If x<low Then
              n=4:x=x+1
            EndIf
          Else
            n=n-1
          EndIf
        EndIf
        Poke var G(0),i*8+2,n+(sf-9)*8:Poke var G(0),i*8+3,x:y=y*8+8:x=x*8-8
        Sprite off sn:Sprite copy sf+(n Xor 4) To sn:Sprite on sn,x,y
        If y=pY Then
          If Abs(x-pX)<9 Then
            po
          EndIf
        EndIf
      EndIf
    EndIf
  Next
End Sub

Sub anItm 'animate items
  Local i,a
  If nI=0 Then
    po
  Else
    For i=0 To 5
      a=Peek(VAR I(0),i*4):If a=255 Then Exit For
      If a Then
        If (a And 7)=6 Then a=a-3 Else a=a+1
        Poke var I(0),i*4,a
        Sprite paste 38+(a And 7),Peek(VAR I(0),i*4+1),Peek(VAR I(0),i*4+2)
      EndIf
    Next
  EndIf
End Sub

Sub po
  If nI=0 And (gf And 7)<4 Then
    Colour pPpr,pInk
  Else
    Colour pInk,pPpr
  EndIf
  Print@(pX,pY)Chr$(30)Chr$(31)@(pX,pY+8)Chr$(32)Chr$(33);
End Sub

Sub cr(x,y,p)
  Local a
  a=bga(2)
  Colour z2m(a And 7),z2m((a And 56)\8)
  a=Peek(VAR L(0),p)
  If a=141 Then
    Poke VAR L(0),p,bga(0)
    Print@(x,y)Chr$(21);
  Else
    Poke VAR L(0),p,a+1
    Print@(x,y)Chr$(a-99);
  EndIf
End Sub

Function cs(x,y,c) 'canstand: return false:no 1:yes 3:yes-conveyor left 5:right
  Local p,a1,a2,c1,c2

  p=y*32+x+64:a1=Peek(VAR L(0),p):a2=Peek(VAR L(0),p+1)
  If a1>199 Then
    c1=29
  ElseIf a1>133 Then
    c1=23
  Else
    c1=Peek(VAR a2c(0),a1)
  EndIf
  If a2>199 Then
    c2=29
  ElseIf a2>133 Then
    c2=23
  Else
    c2=Peek(VAR a2c(0),a2)
  EndIf
  If c1=28 Then c1=22 'low spare is floor
  If c2=28 Then c2=22
  If c1=26 Or c1=27 Or c2=26 Or c2=27 Then wC=2 'nasty - die
  If c Then
    If c1=23 Then cr(x*8-8,y*8+24,p)
    If c2=23 Then cr(x*8,y*8+24,p+1)
  EndIf
  If (c1>=22 And c1<=25)Or(c2>=22 And c2<=25) Then
    cs=1
    If c1=25 Or c2=25 Then cs=3:If Peek(var L(0),623)Then cs=5
  EndIf
End Function

Sub mw(x,y) 'try To move Willy. wC bit 0:moved, wC bit 1:died
  Local nX,nY,nP,nS,c1,c2,c3,r 'local cs are chars, not conveyors
  nX=wX:nY=wY:nP=wPy:nS=wS:pd=x
  If x<0 Then 'move left (one pixel max)
    If nS Then 'can use next leftmost sprite
      wC=wC Or 1:nS=nS-1
    Else
      nS=3:nX=nX-1
    EndIf
  EndIf
  If x>0 Then 'move right (one pixel max)
    If nS<3 Then 'can use next rightmost sprite
      wC=wC Or 1:nS=nS+1
    Else
      nS=0:nX=nX+1
    EndIf
  EndIf
  If y<>0 Then
    If jf=0 Then jf=2000
    nP=nP+y
    If nP<0 Then
      nP=nP+8:nY=nY-1
    ElseIf nP>7 Then
      nP=nP-8:nY=nY+1
    Else
      wC=wC Or 1
    EndIf
  EndIf
  If nY<>wY Then 'can Willy move up/down to a new square?
    If y<0 Then 'going up
      c1=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+wX)) 'nb wX not nX:see Spectrum
      c2=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+wX+1)) 'Central Cavern wall jump
      If c1=24 Or c2=24 Then 'bangs head
        y=0:nY=wY:nP=0:wM=0 'stop jumping
        jf=0
        If (gf And 1)=0 And cs(nX,nY,0) Then nX=wX:nS=wS:pd=0 '1/2 spd
      ElseIf c1=26 Or c1=27 Or c2=26 Or c2=27 Then 'nasty
        wC=2 'die
      EndIf
    Else 'going down
      If nP Then
        r=0
      Else
        r=cs(nx,nY,0)
      EndIf
      If r Then
        If nP Then nY=wY
        nP=0:wM=0 'stop jumping
        If wF<=36 Then wF=0 Else wC=2 'die falling
      EndIf
    EndIf
  EndIf
  If nX<>wX Then 'can Willy move left/right to a new square?
    If nX<1 Or nX>31 Then
      nX=wX:nS=wS
    Else
      c3=21
      If x<0 Then 'going left
        c1=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+nX))
        c2=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+nX+32))
        If nP Then c3=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+nX+64))
      Else 'going right
        c1=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+nX+1))
        c2=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+nX+33))
        If nP Then c3=Peek(VAR a2c(0),Peek(VAR L(0),nY*32+nX+65))
      EndIf
      If c1=24 Or c2=24 Or c3=24 Then 'up against wall
        nX=wX:nS=wS
      EndIf
    EndIf
  EndIf
  If wX<>nX Or wY<>ny Then wC=wC Or 1
  wX=nX:wY=nY:wPy=nP:wS=nS
  If y<=0 Then
    wF=0
  Else
    wF=wF+y:If wF>=20 Then wM=wM And &HFFF9:pd=0 'fall straight down
  EndIf
  If wC=1 Then
    If y<0 Then jf=jf*9/8 Else jf=jf*8/9:If jf<>0 And jf<500 Then jf=2000
  EndIf
End Sub

Sub wi(m) 'bit 0=jump, bit 1=left, bit 2=right
  Local a,i,j,k,p,x,y
  wC=0 'bit 0:Willy sprite changes, bit 1:he dies
  ow=m And 6 'previous left/right input for keyboard running jump
  If wM=0 Then
'normal mode
    jf=0:k=cs(wX,wY,1)
    If k>1 Then
      x=Peek(VAR L(0),623)
      If ((m And 2)=2 And x<>0) Or ((m And 4)=4 And x=0)Then
        m=m And 1:If pd<0 Then m=m Or 2 Else If pd>0 Then m=m Or 4
      Else
        m=(m And 1)Or 2:If x Then m=(m And 1)Or 4
      EndIf
    EndIf
    If k=0 Then 'fall: falls at terminal velocity
      wM=&B10001001 'wrong physics, but Spectrum authentic
    Else
      If(m And 2)<>0 Then If wD=0 Then wC=wC Or 1:wD=1:m=m And 1:pd=0
      If(m And 4)<>0 Then If wD=1 Then wC=wC Or 1:wD=0:m=m And 1:pd=0
      If m And 1 Then
        wM=m 'set jumping bit(s)
      Else
        If m And 2 Then mw -1,0 'walk left
        If m And 4 Then mw 1,0 'walk right
      EndIf
    EndIf
  EndIf
  If wM And 1 Then
'Willy jumping
    x=0
    If wM And 2 Then 'trying to jump left
      If wD Then 'and facing left
        x=-1
      EndIf
    EndIf
    If wM And 4 Then 'trying to jump right
      If wD=0 Then 'and facing right
        x=1
      EndIf
    EndIf
    j=(wM And &B11111000)\8:y=(j-8.5)\2:j=j+1
    If j>17 Then
      j=17
    Else
      wM=(wM And 7)Or(j*8)
    EndIf
    mw x,y
  EndIf
  'switch off Willy sprite while animating conveyor if he overlaps it
  If wX*8-8-x<=c9 And wX*8+7-x>=c3 Then
    If wY*8+wPy+23-y>=c7 And wY*8+wPy+8-y<=c8 Then
      wC=wC Or 1:Sprite off 53
    EndIf
  EndIf
  BLIT c1,c2,c3,c2,c4,1:BLIT c3,c2,c5,c2,8,1
  BLIT c3,c6,c1,c6,c4,1:BLIT c5,c6,c3,c6,8,1
  If wC Then
    Sprite off 53:Sprite copy wS+wD*4+1 To 53
    If dm=0 Then Sprite on 53,wX*8-8,wY*8+8+wPy:po
    'redraw any attributes Willy is behind

    k=wY+1:If wPy Then k=k+1 'Willy can occupy 4 or 6 attribute squares
    p=0:For y=wY To k
      i=y*32
      For x=wX To wX+1
        a=Peek(VAR L(0),i+x) 'attribute
        If a<>bga(0) Then
        If a>=200 Then 'collecting item
          Poke VAR L(0),i+x,bga(0)
          Poke VAR I(0),(a-200)*4,0
          j=Peek(VAR I(0),(a-200)*4+1):a=Peek(VAR I(0),(a-200)*4+2)
          Sprite Off 53:Line(j,a)-(j+7,a+7),bg,BF
          If dm=0 Then Sprite On 53,wX*8-8,wY*8+8+wPy
          nI=nI-1
          score(100)
        ElseIf a>129 And a<134 Then 'portal square
          If nI=0 Then p=p+1:If p>2 Then wC=wC Or 4 'next level
        Else
          j=Peek(VAR a2c(0),a)
          If j<>25 Then 'redraw except conveyor
            If j=28 And (lev=8 Or lev=12) Then 'kong switches
              j=23:Colour z2m(a And 7),z2m((a And 56)\8)
              Print@(x*8-8,y*8+8)Chr$(j);
              If x=6 Then
                If Peek(VAR L(0),369)<>bga(0) Then 'wall, alter grdn 2
                  Colour bg,bg:Print@(128,96)Chr$(21)@(128,104)Chr$(21);
                  Poke VAR L(0),369,bga(0):Poke VAR L(0),401,bga(0)
                  Poke VAR G(0),23,18
                EndIf
              ElseIf Peek(VAR L(0),79)<>bga(0) Then 'remove platform, kill kong
                Colour bg,bg:Print@(112,24)Chr$(21)Chr$(21);
                Poke VAR L(0),79,bga(0):Poke VAR L(0),80,bga(0)
                Poke VAR G(0),2,11:kf=6183
              EndIf
            EndIf
            If a>133 Then a=bga(2) 'crumbling floor
            Colour z2m(a And 7),z2m((a And 56)\8)
            Print@(x*8-8,y*8+8,1)Chr$(j);
            If j=26 Or j=27 Then wC=2 'nasty: die
          EndIf
        EndIf
        EndIf
      Next
    Next
  EndIf
End Sub

Sub air(a) 'wC bit 1 Willy suffocates
  Local s
  ai=ai-a/8:If ai<0 Then ai=0:wC=wC Or 2
  s=32.5+ai*206/222:a=Int(s)
  If a<72 Then Line(a,146)-(oS,149),4,BF:If oS>=72 Then a=72
  If a>=72 Then Line(a,146)-(oS,149),2,BF
  oS=Int(s)
End Sub

Sub score(p)
  Local os
  os=sc
  sc=sc+p:Font#4:Colour 6,0:Print@(192,160)Format$(sc,"%06.0f");:Font#5
  If sc\10000-os\10000 Then nL=nL+1
End Sub

Sub s1
  Local i,c1,c2,c3,s,x1,y1,x2,y2
  For i=40 To 53:Sprite off i:Next
  For i=0 To 3
    Do
      c1=Peek(VAR S(0),pS):pS=pS+1:If c1=0 Then Exit Do
      c2=Peek(VAR S(0),pS):pS=pS+1:c3=Peek(VAR S(0),pS):pS=pS+1
      s=c1\16:x1=(c1 And 15)*2:If c2 And 128 Then x1=x1+1
      y1=(c2 And 124)\4:x2=(c2 And 3)*8 Or (c3 And 224)\32:y2=c3 And 31
      If i And 1 Then
        BLIT x1*8,y1*8,x2*8,y2*8,8,s*8
      Else
        BLIT x1*8,y1*8,x2*8,y2*8,s*8,8
      EndIf
    Loop
  Next
  Sprite On 53,wX*8-8,wY*8+8+wPy
  fS=fS+Peek(VAR S(0),pS):pS=pS+1
End Sub

Sub s2
  Local x,y,n
  x=wX*8-8:y=wY*8+8:n=0
  If wPy Then
    Sprite off 53
    If Pixel(x,y+16)=6 Then n=n+1
    If Pixel(x+15,y+16)=6 Then n=n+1
  EndIf
  If n<2 Then
    If Pixel(x,y)=6 Then n=n+1
    If Pixel(x+15,y)=6 Then n=n+1
    If Pixel(x,y+8)=6 Then n=n+1
    If Pixel(x+15,y+8)=6 Then n=n+1
  EndIf
  If wPy Then Sprite On 53,wX*8-8,wY*8+8+wPy
  If n<>0 Then air(4*n)
End Sub

Sub sL 'show lives
  Local i,j
  j=nL-2:If j>8 Then j=8
  For i=0 To j:Sprite paste 54,i*16,176:Next:If j<0 Then i=0
  If cm Then Font#6:Colour 3:Print@(i*16,176)Chr$(21);:Font#5
End Sub

Sub ss
  If mm Then fms=1000/mfps Else fms=1000/sfps
End Sub

Sub tt
  Local p,s,f,d,n1,n2,i,t 'd duration, n1,n2 notes 1 and 2

  Open"DATA\TTL_DATA.BIN"For input As#1
  For i=0 To 287:Poke var L(0),i,Asc(Input$(1,#1)):Next
  Do
    p=Asc(Input$(1,#1)):Poke VAR L(0),i,p:i=i+1
  Loop Until p=0
  Close#1
  Sprite Load"SPRITES\MMLEV01.SPR"
  p=31780:s=0.236:f=0.95:i=0:t=Timer
  Do
    d=0:If js Then d=Port(jsF,1,jsL,1,jsR,1)Xor jsM
    If Inkey$<>"" Or (d And 1) Then p=0:Exit Do
    d=Peek(var L(0),i):i=i+1:If d=255 Then Exit Do
    n1=Peek(var L(0),i):i=i+1:n2=Peek(var L(0),i):i=i+1
    Do While Timer<t
    Loop
    t=t+d*f/s
    If n1<>0 And n2<>0 Then
      Tone p/n2,p/n1
    ElseIf n1<>0 Then
      Tone p/n1
    ElseIf n2<>0 Then
      Tone p/n2
    Else
      Tone stop
    EndIf
    If n1<>0 Then n1=30-(n1-8)\8:Line(n1*8,128)-(n1*8+6,135),4,BF 'red note
    If n2<>0 Then n2=30-(n2-8)\8:Line(n2*8,128)-(n2*8+6,135),3,BF 'cyan note
    Do While Timer<t
    Loop
    Tone stop
    Line(n1*8,128)-(n1*8+6,135),7,BF 'white note
    Line(n2*8,128)-(n2*8+6,135),7,BF 'white note
    t=t+d*(1-f)/s
  Loop
  If p=0 Then Sprite unload:Exit Sub
  Line(224,80)-(239,95),4,BF:Sprite copy 1 To 53:Sprite on 53,224,80
  Colour 6,0:Font#4:Print@(0,160);
  For i=288 To 317:Print Chr$(Peek(var L(0),i));:Next
  Timer=0:f=0:gf=0
  Do
    d=0:If js Then d=Port(jsF,1,jsL,1,jsR,1)Xor jsM
    If Inkey$<>"" Or (d And 1) Then p=0:Exit Do
    Do While Timer<f
    Loop
    f=f+12.5:gf=gf+1
    If (gf And 7)=0 Then
      Sprite copy (gf And 48)\8+1 To 53
      BLIT 8,160,0,160,232,8
      s=Peek(VAR L(0),i):i=i+1:If s=0 Then Exit Do
      Print@(232,160)Chr$(s);
    EndIf
  Loop
  Sprite unload
  dm=0:If p Then dm=1 'demo mode
End Sub

Font Load"FONTS\SPECTRUM.FNT"As#4
Font Load"FONTS\SPECIAL.FNT"As#6

pM=0:Open "DATA\GAMETUNE.BIN"For input As#1
Do
  k=Asc(Input$(1,#1)):Poke VAR M(0),pM,k:pM=pM+1
Loop Until k=0
Close#1:pM=0

If js Then SetPin jsL,DIN:SetPin jsR,DIN:SetPin jsF,DIN
hs=0:cm=0:mm=1:sm=1 'high score cheat mode, music on, sound on
restart:
Do While KeyDown And Inkey$<>"":Loop
tt
sc=0:lev=1:nL=3 'score,start level and number of lives
Do
  il lev:po:sL:ss:Timer=0:ft=Timer+fms:jf=0:kf=0:gf=0:pM=0
  If dm Then Sprite off 53
  Do
    j=0:If js Then j=Port(jsF,1,jsL,1,jsR,1)Xor jsM
    k=KeyDown
    If k=32 Or k=128 Then 'space or up - jump
      j=j Or(1+ow)
    ElseIf k=130 Then 'left
      j=j Or 2
    ElseIf k=131 Then 'right
      j=j Or 4
    EndIf:k=k Or 32
    If dm Then j=j And 1
    If lev=19 Then
      If gf=fS Then s1
      mvGrd():wi j:s2
    Else
      mvgrd():wi j
    EndIf
    air(1)
    'exit loop if Willy dies or progresses to next level
    If dm Then
      If j And 1 Then Exit Do
      If gf=64 Then k=168:Exit Do
    Else
      If((wC And 6)<>0 Or(Collision(53,SPRITE)And 16)<>0) Then Exit Do
      'If (wC And 4)<>0 Then Exit Do
    EndIf
    anItm
    af=jf:If af=0 And kf<>0 Then af=kf
    If mm Then
      If (gf And 1)=0 Then
        i=Peek(VAR M(0),pM):pM=pM+1:If i=0 Then i=Peek(VAR M(0),pM):pM=1
        f=i*1.341+340
      EndIf
      If sm=0 Or af=0 Then
        Tone f,f,nd
      Else
        Tone f,af,nd
      EndIf
      If (gf And 3)=1 Then
       j=nL-2:If j>8 Then j=8
       For i=0 To j:Sprite paste 54 + (gf And 12)\4,i*16,176:Next
      EndIf
    ElseIf sm<>0 And af<>0 Then
      Tone af,af,nd
    EndIf
    Do While Timer<ft
    Loop
    ft=ft+fms
    gf=gf+1
    If k<>ok Then
      If k>47 And k<58 Then
        cl=(cl*10+k-48):ch=(ch*10+cl\1e4)Mod 1e3:cl=cl Mod 1e4
        If ch=603 And cl=1769 Then cm=1:sL:kp("PgUp/Dn")
        If ch=271 And cl=8281 Then nL=1E9:sL
      ElseIf k=109 Then 'M/m toggle music
        mm=1-mm:ss
      ElseIf k=115 Then 'S/s toggle sound
        sm=1-sm
      ElseIf k=112 Then 'P/p pause
        Do
          k$=Inkey$
        Loop Until k$=""
        Do
          k=Asc(Inkey$)Or 32:If k=113 Then Exit Do 'q to quit
        Loop Until k=112 'P/p unpause
        If k<>113 Then k=0
        Do
          k$=Inkey$
        Loop Until k$="" And KeyDown=0
        ft=Timer+fms
      EndIf
    EndIf
    ok=k
  Loop Until k=113 Or (cm<>0 And (k=168 Or k=169)) 'q,PgUp,PgDn
  If k=169 Then
    lev=lev-1:If lev=0 Then lev=20 'PgDn
  ElseIf k=168 Then
    lev=lev+1:If lev=21 Then lev=1 'PgUp
  ElseIf k=113 Then
    Exit Do
  ElseIf(wC And 6)=4 Then 'portal to next level
    If lev=20 And cm=0 Then
      Sprite off 53:Sprite copy 4 To 53:Sprite on 40,pX,pY
      Line(pX,pY-24)-(pX+15,pY-17),3,BF:Line(pX,pY-16)-(pX+15,pY-9),2,BF
      Sprite on 53,pX,pY-24
      If sm Then
        Timer=0
        Do While Timer<6400
          i=Timer Mod 125
          f=500+i*10
          Tone f,f
        Loop
        Tone stop
      Else
        Pause 6400
      EndIf
    EndIf
    Do While ai
      If sm Then Tone 2000+ai*4,1900+ai*4,50
      Pause 6
      air(7):score 7
    Loop
    lev=lev+1:If lev=21 Then lev=1
  ElseIf dm Then
    dm=0:lev=1
  Else
    If sm Then
      f=4410:j=8:k=0.5
      Do
        Tone f,f/2,j
        Pause j+6
        j=j+(18.5-j)*k:If j>17 Then k=-1
      Loop Until j<2
      Tone f,f/2,2
    Else
      Pause 127
    EndIf
    Pause 8
    nL=nL-1:If nL=0 Then
      Sprite off 53:Sprite copy 3 To 53
      Line(0,8)-(239,135),0,BF
      Font#6:Color 7,0:Print@(112,120)Chr$(20);
      Sprite on 53,112,104
      jf=525:k=(2039/525)^(1/48):f=32E3/jf:ft=Timer+f+6.3
      For i=8 To 104 Step 2
        Print@(112,i)Chr$(21);
        If sm Then
          Tone jf,jf,f
        EndIf
        Do
        Loop Until Timer>ft
        jf=jf*k:f=32E3/jf:ft=ft+f+6.3
      Next
      ft=Timer+2000
      Font#4:k=1
      Do
        Print@(72,56);
        For i=1 To 8
          If i=5 Then Print@(136,56);
          Colour k:k=k+1:If k=8 Then k=1
          Print Mid$("GameOver",i,1);
          If sc>hs Then hs=sc
        Next
        Pause 40
      Loop Until Timer>ft
      Sprite unload:Font#4:Font unload#5
      Exit Do
    EndIf
  EndIf
  Sprite unload:Font#4:Font unload#5
Loop
If k<>113 Then LoadBMP"GRAPHICS\TITLESCR.BMP":GoTo restart
Font#1:Font unload#4:Font unload#5:Font unload#6:Sprite unload:Print@(0,180);

